//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "MainForm.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "Chart"
#pragma link "TeeChartGrid"
#pragma link "TeEngine"
#pragma link "TeeProcs"
#pragma link "TeeSurfa"
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
   : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::StringGrid1DoubleClick(TObject *Sender)
{
   double gridValues[6] = { 5.153, 5.154, 5.155, 5.156, 5.157, 5.158 };
   int randomIndex = rand() % 6;

   StringGrid1->Cells[Column][Row] = gridValues[randomIndex];

   Draw();
/*
   Draw();
   Draw();
   Draw();
*/
}
//---------------------------------------------------------------------------
void __fastcall TForm1::StringGrid1SelectCell(TObject *Sender, int ACol, int ARow,
          bool &CanSelect)
{
   Column = ACol;
   Row = ARow;
}
//---------------------------------------------------------------------------
void TForm1::Draw()
{
   double seriesDefaultValue = 0.0;

   // Remove default/old entries from series
   for (int i = 0; i < Series1->Count(); i++) {
      Series1->Delete(i);
   }

   // Fill Series with StringGrid1 data
   for (int rowIdx = 0; rowIdx < StringGrid1->RowCount; rowIdx++) {
      for (int colIdx = 0; colIdx < StringGrid1->ColCount; colIdx++) {
         Series1->AddXYZ(colIdx, verifyDouble(StringGrid1->Cells[colIdx][rowIdx], &seriesDefaultValue), rowIdx);
      }
   }
}
//---------------------------------------------------------------------------
double TForm1::verifyDouble(UnicodeString input, double* defaultValue) {
   if (input == "") {
      return *defaultValue;
   }

   return input.ToDouble();
}
void __fastcall TForm1::FormShow(TObject *Sender)
{
   // Legend colors
   TColor clHigh = RGB(255, 0, 0);
   TColor clMid = RGB(255, 255, 0);
   TColor clLow = RGB(0, 180, 230);

   // TeeChart defaults
   Chart1->Legend->Visible = false;
   Chart1->Axes->Visible = false;
   Chart1->Title->Visible = false;
   Chart1->MarginLeft = 0;
   Chart1->MarginTop = 0;
   Chart1->MarginRight = 0;
   Chart1->MarginBottom = 0;

   Series1->Pen->Visible = false;
   Series1->Brush->Style = bsSolid;
   Series1->GetVertAxis->Inverted = true;
   Series1->UsePalette = false;
   Series1->UseColorRange = true;
   Series1->StartColor = clHigh;
   Series1->MidColor = clMid;
   Series1->EndColor = clLow;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button1Click(TObject *Sender)
{
   Draw();
}
//---------------------------------------------------------------------------

